## sundials 7.1.1+dfsg1

=== CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Radu Serban, David J. Gardner, Cody J. Balos,
#                and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# Top level CMakeLists.txt for SUNDIALS (for cmake build system)
# ---------------------------------------------------------------

# ===============================================================
# Initial setup.
# ===============================================================

cmake_minimum_required(VERSION 3.18)

# Address DOWNLOAD_EXTRACT_TIMESTAMP warning with CMake 3.24+
if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.24")
  cmake_policy(SET CMP0135 NEW)
endif()

# Project SUNDIALS (initially only C supported)
# sets PROJECT_SOURCE_DIR and PROJECT_BINARY_DIR variables.
project(SUNDIALS C)

# Specify the location of additional CMAKE modules
set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  ${PROJECT_SOURCE_DIR}/cmake
  ${PROJECT_SOURCE_DIR}/cmake/macros
  ${PROJECT_SOURCE_DIR}/cmake/tpl
  )

# MACRO definitions
include(SundialsCMakeMacros)
include(CMakePrintHelpers)
include(CheckCSourceCompiles)
include(FindPackageHandleStandardArgs)


# Set some variables with info on the SUNDIALS project
set(PACKAGE_BUGREPORT "sundials-users@llnl.gov")
set(PACKAGE_NAME "SUNDIALS")
set(PACKAGE_STRING "SUNDIALS 7.1.1")
set(PACKAGE_TARNAME "sundials")

# Set SUNDIALS version numbers
sundials_git_version() # sets SUNDIALS_GIT_VERSION
message(STATUS "SUNDIALS_GIT_VERSION: ${SUNDIALS_GIT_VERSION}")

# (use "" for the version label if none is needed)
set(PACKAGE_VERSION_MAJOR "7")
set(PACKAGE_VERSION_MINOR "1")
set(PACKAGE_VERSION_PATCH "1")
set(PACKAGE_VERSION_LABEL "")

if(PACKAGE_VERSION_LABEL)
  set(PACKAGE_VERSION
      "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}-${PACKAGE_VERSION_LABEL}"
  )
else()
  set(PACKAGE_VERSION
      "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}"
  )
endif()

# Specify the VERSION and SOVERSION for shared libraries

set(arkodelib_VERSION "6.1.1")
set(arkodelib_SOVERSION "6")

set(cvodelib_VERSION "7.1.1")
set(cvodelib_SOVERSION "7")

set(cvodeslib_VERSION "7.1.1")
set(cvodeslib_SOVERSION "7")

set(idalib_VERSION "7.1.1")
set(idalib_SOVERSION "7")

set(idaslib_VERSION "6.1.1")
set(idaslib_SOVERSION "6")

set(kinsollib_VERSION "7.1.1")
set(kinsollib_SOVERSION "7")

set(cpodeslib_VERSION "0.0.0")
set(cpodeslib_SOVERSION "0")

set(nveclib_VERSION "7.1.1")
set(nveclib_SOVERSION "7")

set(sunmatrixlib_VERSION "5.1.1")
set(sunmatrixlib_SOVERSION "5")

set(sunlinsollib_VERSION "5.1.1")
set(sunlinsollib_SOVERSION "5")

set(sunnonlinsollib_VERSION "4.1.1")
set(sunnonlinsollib_SOVERSION "4")

set(sundialslib_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}"
)
set(sundialslib_SOVERSION "${PACKAGE_VERSION_MAJOR}")

# ===============================================================
# Initial Setup
# ===============================================================

# Prohibit in-source build
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source build prohibited.")
endif()

# Organize targets into folders when using an IDE
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Get correct build paths automatically, but expose LIBDIR and
# INCLUDEDIR as a regular cache variable so that a user can more
# easily see what they were set to by GNUInstallDirs.
include(GNUInstallDirs)
mark_as_advanced(CLEAR CMAKE_INSTALL_LIBDIR)
mark_as_advanced(CLEAR CMAKE_INSTALL_INCLUDEDIR)

# Suffixes to use for static and shared targets.
set(_STATIC_LIB_SUFFIX
    "_static"
    CACHE INTERNAL "" FORCE
)
set(_SHARED_LIB_SUFFIX
    "_shared"
    CACHE INTERNAL "" FORCE
)

# A list of all the alias targets created.
set(_SUNDIALS_ALIAS_TARGETS ""
    CACHE INTERNAL "" FORCE)

# We default to release builds
set(_DEFAULT_CMAKE_BUILD_TYPE RelWithDebInfo)
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Building SUNDIALS in '${_DEFAULT_CMAKE_BUILD_TYPE}' mode as CMAKE_BUILD_TYPE was not specified.")
  set(CMAKE_BUILD_TYPE "${_DEFAULT_CMAKE_BUILD_TYPE}" CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
else()
  message(STATUS "Building SUNDIALS in '${CMAKE_BUILD_TYPE}' mode.")
endif()

# ===============================================================
# Build options to be processed first
# ===============================================================

include(SundialsDeprecated)
include(SundialsBuildOptionsPre)

# ===============================================================
# Options for external packages
# ===============================================================

include(SundialsTPLOptions)

# ===============================================================
# Options for examples
# ===============================================================

include(SundialsExampleOptions)

# ===============================================================
# Setup compilers
# ===============================================================

include(SundialsSetupCompilers)

# ===============================================================
# Setup third-party libraries
# ===============================================================

include(SundialsSetupTPLs)

# ===============================================================
# Build options to be proccessed last
# ===============================================================

include(SundialsBuildOptionsPost)

# ===============================================================
# At this point all the configuration options are set.
# Setup the sundials_config.h.
# ===============================================================

include(SundialsSetupConfig)

# ===============================================================
# Add src and tests; optionally add examples and unit tests.
# ===============================================================

# Add selected packages and modules to the build
add_subdirectory(src)

# Add selected examples to the build
if(_BUILD_EXAMPLES)
  include(SundialsSetupTesting)
  add_subdirectory(examples)
endif()

# Add benchmarks to the build
if(BUILD_BENCHMARKS)
  add_subdirectory(benchmarks)
endif()

# Add unit tests to the build if they are enabled
if(SUNDIALS_TEST_UNITTESTS)
  add_subdirectory(test/unit_tests)
endif()

if(SUNDIALS_ENABLE_EXTERNAL_ADDONS)
  add_subdirectory(external)
endif()

# ===============================================================
# Install configuration header files and license file.
# ===============================================================

# install sundials_export header file
install(FILES "${PROJECT_BINARY_DIR}/include/sundials/sundials_export.h"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials"
)

# install configured header file
install(FILES "${PROJECT_BINARY_DIR}/include/sundials/sundials_config.h"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials"
)

# install shared Fortran 2003 modules
if(BUILD_FORTRAN_MODULE_INTERFACE)
  # While the .mod files get generated for static and shared
  # libraries, they are identical. So only install one set
  # of the .mod files.
  if(BUILD_STATIC_LIBS)
    install(DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}_STATIC/
            DESTINATION ${Fortran_INSTALL_MODDIR}
    )
  else()
    install(DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}_SHARED/
            DESTINATION ${Fortran_INSTALL_MODDIR}
    )
  endif()
endif()

# install license and notice files
install(FILES "${PROJECT_SOURCE_DIR}/LICENSE"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials"
)
install(FILES "${PROJECT_SOURCE_DIR}/NOTICE"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials"
)

# create package version file
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  SUNDIALSConfigVersion.cmake
  VERSION ${PACKAGE_VERSION}
  COMPATIBILITY AnyNewerVersion
)

# install targets
install(
  EXPORT sundials-targets
  FILE SUNDIALSTargets.cmake
  NAMESPACE SUNDIALS::
  DESTINATION "${SUNDIALS_INSTALL_CMAKEDIR}"
)

# install SUNDIALSConfig.cmake
configure_package_config_file(
  "${PROJECT_SOURCE_DIR}/cmake/SUNDIALSConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSConfig.cmake"
  INSTALL_DESTINATION "${SUNDIALS_INSTALL_CMAKEDIR}"
)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSConfig.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSConfigVersion.cmake"
        DESTINATION "${SUNDIALS_INSTALL_CMAKEDIR}"
)

# Export targets so build directory can be used directly
export(
  EXPORT sundials-targets
  FILE "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSTargets.cmake"
  NAMESPACE SUNDIALS::
)

=== benchmarks/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# benchmarks level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

if(NOT (CMAKE_BUILD_TYPE STREQUAL "Release" OR
      CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo"))
  message(WARNING "SUNDIALS is not being built in a \"Release\" mode, "
          "benchmark performance will be affected")
endif()

sundials_option(BENCHMARK_NVECTOR BOOL "NVector benchmarks are on" ON)

# Disable some warnings for benchmarks
if(ENABLE_ALL_WARNINGS)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-parameter")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
endif()

#----------------------------------------
# Add specific benchmarks
#----------------------------------------

if(ENABLE_MPI)
add_subdirectory(diffusion_2D)
add_subdirectory(advection_reaction_3D)
endif()

# Add the nvector benchmarks
if(BENCHMARK_NVECTOR)
  add_subdirectory(nvector)
endif()

=== doc/Makefile ===
# ------------------------------------------------------------------------------
# Programmer(s): David J. Gardner @ LLNL
# ------------------------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ------------------------------------------------------------------------------
# Makefile to build or clean all RST package docs at once
# ------------------------------------------------------------------------------

DIRS = arkode/guide arkode/examples \
       cvode/guide \
       cvodes/guide \
       ida/guide \
       idas/guide \
       kinsol/guide

# prefix with desired command to create unique dependencies/targets
LATEXDIRS = $(DIRS:%=latexpdf-%)
HTMLDIRS = $(DIRS:%=html-%) html-superbuild
CLEANDIRS = $(DIRS:%=clean-%) clean-superbuild

latexpdf: $(LATEXDIRS)
$(LATEXDIRS):
	$(MAKE) -C $(@:latexpdf-%=%) latexpdf

html: $(HTMLDIRS)
$(HTMLDIRS):
	$(MAKE) -C $(@:html-%=%) html

clean: $(CLEANDIRS)
$(CLEANDIRS):
	$(MAKE) -C $(@:clean-%=%) clean

.PHONY: $(LATEXDIRS)
.PHONY: $(HTMLDIRS)
.PHONY: $(CLEANDIRS)
.PHONY: latexpdf html clean

=== doc/requirements.txt ===
sphinx >=4.0.0
sphinx-fortran
sphinx_rtd_theme
sphinxcontrib.bibtex
sphinx-copybutton

=== swig/Makefile ===
# ---------------------------------------------------------------
# Programmer: Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# Makefile to generate SUNDIALS fortran interfaces with swig
# ---------------------------------------------------------------

SWIG ?= swig

ARKODE=farkode_mod farkode_arkstep_mod farkode_erkstep_mod farkode_sprkstep_mod farkode_mristep_mod
CVODE=fcvode_mod
CVODES=fcvodes_mod
IDA=fida_mod
IDAS=fidas_mod
KINSOL=fkinsol_mod
CORE=fsundials_core_mod
NVECTOR=openmp pthreads serial parallel manyvector mpiplusx
SUNMATRIX=band dense sparse
SUNLINSOL=band dense lapackdense klu spbcgs spfgmr spgmr sptfqmr pcg
SUNNONLINSOL=newton fixedpoint
SUNADAPTCONTROLLER=imexgus soderlind

INCLUDES=-I../include

.PHONY: .SETINT64 .SETINT32 all all32 all64 modules core arkode cvode cvodes ida idas kinsol nvector mpimanyvector sunmatrix sunlinsol sunnonlinsol sunadaptcontroller clean

.SETINT32:
	$(eval INT_SIZE=32)

.SETINT64:
	$(eval INT_SIZE=64)

all: all32 all64

all32: .SETINT32 modules

all64: .SETINT64 modules

modules: core arkode cvode cvodes ida idas kinsol nvector sunmatrix sunlinsol sunnonlinsol sunadaptcontroller

core: $(CORE:%:sundials/%.i)
	@for i in ${CORE} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/sundials/fmod_int${INT_SIZE} -o ../src/sundials/fmod_int${INT_SIZE}/$${i}.c ${INCLUDES} sundials/$${i}.i; \
	done

arkode: $(ARKODE:%:arkode/%.i)
	@for i in ${ARKODE} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/arkode/fmod_int${INT_SIZE} -o ../src/arkode/fmod_int${INT_SIZE}/$${i}.c ${INCLUDES} arkode/$${i}.i; \
	done

cvode: $(CVODE:%:cvode/%.i)
	@for i in ${CVODE} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/cvode/fmod_int${INT_SIZE} -o ../src/cvode/fmod_int${INT_SIZE}/$${i}.c ${INCLUDES} cvode/$${i}.i; \
	done

cvodes: $(CVODE:%:cvodes/%.i)
	@for i in ${CVODES} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/cvodes/fmod_int${INT_SIZE} -o ../src/cvodes/fmod_int${INT_SIZE}/$${i}.c ${INCLUDES} cvodes/$${i}.i; \
	done

ida: $(IDA:%:ida/%.i)
	@for i in ${IDA} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/ida/fmod_int${INT_SIZE} -o ../src/ida/fmod_int${INT_SIZE}/$${i}.c ${INCLUDES} ida/$${i}.i; \
	done

idas: $(IDAS:%:idas/%.i)
	@for i in ${IDAS} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/idas/fmod_int${INT_SIZE} -o ../src/idas/fmod_int${INT_SIZE}/$${i}.c ${INCLUDES} idas/$${i}.i; \
	done

kinsol: $(KINSOL:%:kinsol/%.i)
	@for i in ${KINSOL} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/kinsol/fmod_int${INT_SIZE} -o ../src/kinsol/fmod_int${INT_SIZE}/$${i}.c ${INCLUDES} kinsol/$${i}.i; \
	done

nvector: $(NVECTOR:%:nvector/fnvector_%_mod.i) mpimanyvector
	@for i in ${NVECTOR} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/nvector/$${i}/fmod_int${INT_SIZE} -o ../src/nvector/$${i}/fmod_int${INT_SIZE}/fnvector_$${i}_mod.c ${INCLUDES} nvector/fnvector_$${i}_mod.i; \
	done

mpimanyvector: nvector/fnvector_mpimanyvector_mod.i
	set -x; \
	${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/nvector/manyvector/fmod_int${INT_SIZE} -o ../src/nvector/manyvector/fmod_int${INT_SIZE}/fnvector_mpimanyvector_mod.c ${INCLUDES} nvector/fnvector_mpimanyvector_mod.i;

sunmatrix: $(SUNMATRIX:%:sunmatrix/fsunmatrix_%_mod.i)
	@for i in ${SUNMATRIX} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/sunmatrix/$${i}/fmod_int${INT_SIZE} -o ../src/sunmatrix/$${i}/fmod_int${INT_SIZE}/fsunmatrix_$${i}_mod.c ${INCLUDES} sunmatrix/fsunmatrix_$${i}_mod.i; \
	done

sunlinsol: $(SUNLINSOL:%:sunlinsol/fsunlinsol_%_mod.i)
	@for i in ${SUNLINSOL} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/sunlinsol/$${i}/fmod_int${INT_SIZE} -o ../src/sunlinsol/$${i}/fmod_int${INT_SIZE}/fsunlinsol_$${i}_mod.c ${INCLUDES} sunlinsol/fsunlinsol_$${i}_mod.i; \
	done

sunnonlinsol: $(SUNNONLINSOL:%:sunnonlinsol/fsunnonlinsol_%_mod.i)
	@for i in ${SUNNONLINSOL} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/sunnonlinsol/$${i}/fmod_int${INT_SIZE} -o ../src/sunnonlinsol/$${i}/fmod_int${INT_SIZE}/fsunnonlinsol_$${i}_mod.c ${INCLUDES} sunnonlinsol/fsunnonlinsol_$${i}_mod.i; \
	done

sunadaptcontroller: $(SUNADAPTCONTROLLER:%:sunadaptcontroller/fsunadaptcontroller_%_mod.i)
	@for i in ${SUNADAPTCONTROLLER} ; do \
		set -x; \
		${SWIG} -DGENERATE_INT${INT_SIZE} -fortran -outdir ../src/sunadaptcontroller/$${i}/fmod_int${INT_SIZE} -o ../src/sunadaptcontroller/$${i}/fmod_int${INT_SIZE}/fsunadaptcontroller_$${i}_mod.c ${INCLUDES} sunadaptcontroller/fsunadaptcontroller_$${i}_mod.i; \
	done

clean:
	rm ../src/**/fmod*/*.c; rm ../src/**/fmod*/*.f90

=== benchmarks/nvector/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# benchmarks/nvector level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

add_subdirectory(serial)

if(BUILD_NVECTOR_PARALLEL)
  add_subdirectory(parallel)
endif()

if(BUILD_NVECTOR_MPIPLUSX)
  add_subdirectory(mpiplusx)
endif()

if(BUILD_NVECTOR_PARHYP)
  add_subdirectory(parhyp)
endif()

if(BUILD_NVECTOR_PTHREADS)
  add_subdirectory(pthreads)
endif()

if(BUILD_NVECTOR_OPENMP)
  add_subdirectory(openmp)
endif()

if(BUILD_NVECTOR_OPENMPDEV)
  add_subdirectory(openmpdev)
endif()

if(BUILD_NVECTOR_PETSC)
  add_subdirectory(petsc)
endif()

if(BUILD_NVECTOR_CUDA)
  add_subdirectory(cuda)
endif()

if(BUILD_NVECTOR_HIP)
  add_subdirectory(hip)
endif()

if(BUILD_NVECTOR_RAJA)
  add_subdirectory(raja)
endif()

if(BUILD_NVECTOR_SYCL)
  add_subdirectory(sycl)
endif()

if(BUILD_NVECTOR_KOKKOS)
  add_subdirectory(kokkos)
endif()

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/plot_nvector_performance_results.py
     DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

=== doc/cvode/Makefile ===
# -----------------------------------------------------------------
# Programmer(s): Slaven Peles, Cody Balos @ LLNL
# -----------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# -----------------------------------------------------------------
# Makefile for CVODE examples documentation
# -----------------------------------------------------------------

EXAMPLES   = cv_examples

EX_FILES = \
${EXAMPLES}.tex \
cv_ex_intro.tex \
cv_ex_serial.tex \
cv_ex_parallel.tex \
cv_ex_parhyp.tex \
cv_ex_tests.tex

# Remove F77 example text
# cv_ex_fortran.tex \

include ../Makefile.in

=== doc/cvodes/Makefile ===
# -----------------------------------------------------------------
# Programmer(s): Slaven Peles, Cody Balos @ LLNL
# -----------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# -----------------------------------------------------------------
# Makefile for CVODES examples documentation
# -----------------------------------------------------------------

EXAMPLES   = cvs_examples

EX_FILES = \
${EXAMPLES}.tex \
cvs_ex_intro.tex \
cvs_ex_fwd.tex \
cvs_ex_adj.tex \
cvs_ex_tests.tex

include ../Makefile.in

=== doc/idas/Makefile ===
# -----------------------------------------------------------------
# Programmer(s): Slaven Peles, Cody Balos @ LLNL
# -----------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# -----------------------------------------------------------------
# Makefile for IDAS examples documentation
# -----------------------------------------------------------------

EXAMPLES   = idas_examples

EX_FILES = \
${EXAMPLES}.tex \
idas_ex_intro.tex \
idas_ex_fwd.tex \
idas_ex_adj.tex

include ../Makefile.in

=== doc/kinsol/Makefile ===
# -----------------------------------------------------------------
# Programmer(s): Slaven Peles, Cody Balos @ LLNL
# -----------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# -----------------------------------------------------------------
# Makefile for KINSOL examples documentation
# -----------------------------------------------------------------

EXAMPLES   = kin_examples

EX_FILES = \
${EXAMPLES}.tex \
kin_ex_intro.tex \
kin_ex_c.tex \
kin_ex_cxx.tex

# Remove F77 examples
# kin_ex_fortran.tex

include ../Makefile.in

=== doc/superbuild/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make all".
all:
	@$(SPHINXBUILD) -M html "$(SOURCEDIR)" "$(BUILDDIR)"

.PHONY: all Makefile

html: all

clean: Makefile
	@$(SPHINXBUILD) -M clean "$(SOURCEDIR)" "$(BUILDDIR)"

=== examples/arkode/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2024, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/arkode level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

# C examples
if(EXAMPLES_ENABLE_C)
  add_subdirectory(C_serial)
  if(BUILD_NVECTOR_MANYVECTOR)
    add_subdirectory(C_manyvector)
  endif()
  if(ENABLE_OPENMP AND OPENMP_FOUND)
    add_subdirectory(C_openmp)
  endif()
  if(ENABLE_OPENMP_DEVICE AND OPENMP_FOUND AND OPENMP_SUPPORTS_DEVICE_OFFLOADING)
    add_subdirectory(C_openmpdev)
  endif()
  if(ENABLE_MPI AND MPI_C_FOUND)
    add_subdirectory(C_parallel)
  endif()
  if(ENABLE_HYPRE AND HYPRE_FOUND)
    add_subdirectory(C_parhyp)
  endif()
  if(ENABLE_PETSC AND PETSC_FOUND)
    add_subdirectory(C_petsc)
  endif()
endif()

# C++ examples
if(EXAMPLES_ENABLE_CXX)
  add_subdirectory(CXX_serial)
  if(ENABLE_MPI AND MPI_CXX_FOUND)
    add_subdirectory(CXX_parallel)
  endif()
  if(ENABLE_MPI AND MPI_CXX_FOUND AND ENABLE_HYPRE AND HYPRE_FOUND)
    add_subdirectory(CXX_parhyp)
  endif()
  if(MPI_CXX_FOUND AND ENABLE_SUPERLUDIST)
    add_subdirectory(CXX_superludist)
  endif()
  if(ENABLE_XBRAID)
    add_subdirectory(CXX_xbraid)
  endif()
endif()

# F2003 examples
if(BUILD_FORTRAN_MODULE_INTERFACE AND EXAMPLES_ENABLE_F2003)
  add_subdirectory(F2003_serial)
  add_subdirectory(F2003_custom)
  if(ENABLE_MPI AND MPI_Fortran_FOUND)
    add_subdirectory(F2003_parallel)
  endif()
endif()

=== debian/changelog ===
sundials (7.1.1+dfsg1-10) unstable; urgency=medium

  * Team upload.
  * debian/tests: drop C_openmp from kinsol (times out on amd64)

 -- Drew Parsons <dparsons@debian.org>  Thu, 13 Mar 2025 10:54:51 +0100

sundials (7.1.1+dfsg1-9) unstable; urgency=medium

  * Team upload.
  * debian/tests: drop arkode test C_openmp. ark_brusselator1D_omp
    passes but ark_heat1D_omp times out on amd64.
  * debian/rules: add powerpc to test skip list

 -- Drew Parsons <dparsons@debian.org>  Wed, 12 Mar 2025 16:09:33 +0100

sundials (7.1.1+dfsg1-8) unstable; urgency=medium

  * Team upload.
  * revert versioned Depends on cmake. The tighter dependency holds up
    migration waiting for cmake, and britney will eventually test
    with the version from unstable anyway. Easier without it.

 -- Drew Parsons <dparsons@debian.org>  Wed, 04 Dec 2024 17:57:26 +0100

sundials (7.1.1+dfsg1-7) unstable; urgency=medium

  * Team upload.
  * the installed example files specify a required cmake version, so
    we need to use a versioned Depends via
    libsundials-dev Depends: ${cmake:Depends}
    Will aid migration to testing when cmake in testing is a lower
    version than unstable.

 -- Drew Parsons <dparsons@debian.org>  Wed, 04 Dec 2024 12:24:05 +0100

sundials (7.1.1+dfsg1-6) unstable; urgency=medium

  * Team upload.
  * debian/tests: drop ida/idas tests. Closes: #1088866.
    The ida(s) FoodWeb tests are slow, and tend to time out.

 -- Drew Parsons <dparsons@debian.org>  Tue, 03 Dec 2024 18:53:28 +0100

sundials (7.1.1+dfsg1-5) unstable; urgency=medium

  * Team upload.
  * debian/rules: Allow oversubscribing to run the tests. Closes: #1086386.

 -- Santiago Vila <sanvila@debian.org>  Sat, 02 Nov 2024 13:05:00 +0100

sundials (7.1.1+dfsg1-4) unstable; urgency=medium

  * Team upload.
  * skip_tests.patch: skip flakey idaFoodWeb_bnd_omp from ida.
    Often times out on many arches.

 -- Drew Parsons <dparsons@debian.org>  Sun, 13 Oct 2024 09:56:57 +0200

sundials (7.1.1+dfsg1-3) unstable; urgency=medium

  * Team upload.
  * add debian patch skip_tests.patch to skip cvsFoodWeb_ASAp_kry and
    cvsRoberts_ASAi_dns_constraints from cvodes test examples.
    They fail sometimes, and fail always on i386.

 -- Drew Parsons <dparsons@debian.org>  Sat, 12 Oct 2024 18:22:08 +0200

sundials (7.1.1+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * upload sundials 7 to unstable. Transition #1082552.
  * add ppc64 to the list of arches skipping some fortran tests

 -- Drew Parsons <dparsons@debian.org>  Thu, 10 Oct 2024 15:51:00 +0200

sundials (7.1.1+dfsg1-1exp2) experimental; urgency=medium

  * Team upload.
  * debian/rules: skip failing fortran tests on s390x sparc64
    from fnvector (manyvector) and fsunlinsol

 -- Drew Parsons <dparsons@debian.org>  Fri, 20 Sep 2024 14:27:16 +0200

sundials (7.1.1+dfsg1-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release
    - deprecates all debian patches
    - provides shared fortran libraries. Closes: #892910.
    - SUNDIALSConfig.cmake KLU support provides include path
      /usr/include/suitesparse for klu.h. Closes: #1069134.
    - supports gcc-14. Closes: #1075547.
  * debian/watch: include index 1 in +dfsg1 name mangling
  * specify -DSUNDIALS_INDEX_SIZE=32 (32-bit integers for indexing)
    for compatibility with PETSc. 64-bit integers would build
    against petsc64-dev not petsc-dev (the latter is default).
    Closes: #1075547.
  * Core libraries (libsundials_core.so.*) provided in new
    libsundials-core7 package. libsundials_generic.so.*
    (formerly in libsundials-sunlinsol3) no longer generated.
  * ABI updates in sublibraries
    - ABI 7
      libsundials-cvode7
      libsundials-cvodes7
      libsundials-ida7
      libsundials-kinsol7
      libsundials-nvec*7
    - ABI 6
      libsundials-arkode6
      libsundials-idas6
    - ABI 5
      libsundials-sunlinsol5
      libsundials-sunmatrix5
    - libsundials-sunlinsol5 also provides:
      libsundials_fsunnonlinsolfixedpoint_mod.so.4
      libsundials_fsunnonlinsolnewton_mod.so.4
      libsundials_sunnonlinsolfixedpoint.so.4
      libsundials_sunnonlinsolnewton.so.4
      libsundials_sunnonlinsolpetscsnes.so.7
  * Depends: pkgconf not pkg-config. Closes: #1077028.
  * update debian/copyright
    - BSD-3-clause with LLNS NOTICE applies to all files (*)
      2002-2024, Lawrence Livermore National Security and
      Southern Methodist University
    - debian/* follows simple BSD-3-clause (Debian maintainers are not
      funded by LLNS contracts)
  * update lintian overrides
    - add package-name-doesnt-match-sonames to all library packages
    - libsundials_nvecparallel now links to libc
  * debian patch sundials_fcore_mod_soname.patch adds soname to
    libsundials_fcore_mod.so (same soversion as libsundials_core.so)
  * debian/tests: use cmake to build and run examples. Run selected
    tests from all components: arkode cvode cvodes ida idas kinsol
    and sunnonlinsol. Skip nvector, sunlinsol, sunmatrix (their tests
    don't pass at the moment).
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Tue, 17 Sep 2024 23:55:57 +0200

=== debian/control ===
Source: sundials
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>,
           James Tocknell <aragilar@gmail.com>,
           Anton Gladky <gladk@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               pkgconf,
               chrpath,
               cmake,
               python3,
               gfortran,
               mpi-default-dev,
               libblas-dev | libblas.so,
               liblapack-dev | liblapack.so,
               petsc-dev,
               libsuitesparse-dev,
               libhypre-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/sundials
Vcs-Git: https://salsa.debian.org/science-team/sundials.git
Homepage: https://www.llnl.gov/CASC/sundials/
Rules-Requires-Root: no

Package: libsundials-core7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 This package contains the library for differential equation (ODE) system
 solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). ARKODE is a solver for multi-rate ODE systems (initial value
 problems) given in explicit form M*dy/dt = f(t,y)
 .
 This package provides core libraries used by other SUNDIALS components.

Package: libsundials-arkode6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 This package contains the library for differential equation (ODE) system
 solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). ARKODE is a solver for multi-rate ODE systems (initial value
 problems) given in explicit form M*dy/dt = f(t,y)

Package: libsundials-cvode7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ordinary differential equation solver (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers). CVODE is a solver for stiff and nonstiff ODE systems
 (initial value problem) given in explicit form dy/dt = f(t,y).

Package: libsundials-cvodes7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ODE solver with sensistivity analysis (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solver with sensistivity analysis capabilities from SUNDIALS (SUite of
 Nonlinear and DIfferential/ALgebraic equation Solvers). CVODES is a solver for
 stiff and nonstiff ODE systems (initial value problem) given in explicit form
 y' = f(t,y,p) with sensitivity analysis capabilities (both forward and adjoint
 modes).

Package: libsundials-ida7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential-algebraic system solver (SUNDIALS library)
 This package contains the library for differential-algebraic system (IDA)
 solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).

Package: libsundials-idas6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: IDA solver with sensitivity capabilities (SUNDIALS library)
 This package contains the library for differential-algebraic system with
 Sensitivity capabilities (IDAS) solver from SUNDIALS (SUite of Nonlinear and
 DIfferential/ALgebraic equation Solvers).

Package: libsundials-kinsol7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: KINSOL solver (SUNDIALS library)
 This package contain the library for KINSOL (nonlinear algebraic systems)
 system solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers).

Package: libsundials-nvecserial7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Non-parallel vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the serial flavor of the library.

Package: libsundials-nvecparallel-mpi7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-bin
Breaks: libsundials-nvecparallel-mpi4 (<<6.4.1+dfsg1-2)
Replaces: libsundials-nvecparallel-mpi4 (<<6.4.1+dfsg1-2)
Description: MPI vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the MPI parallel flavor of the library.

Package: libsundials-nvecparallel-pthread7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Pthread vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the pthread-based parallel flavor of the library.

Package: libsundials-nvecparallel-openmp7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: OpenMP vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the OpenMP-based parallel flavor of the library.

Package: libsundials-nvecparallel-hypre7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: HYPRE vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the HYPRE-based parallel flavor of the library.

Package: libsundials-nvecparallel-petsc7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: PETSc vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the PETSc-based parallel flavor of the library.

Package: libsundials-sunlinsol5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-sunmatrix5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-dev
Architecture: any
Section: libdevel
Depends: libsundials-core7                 (= ${binary:Version}),
         libsundials-arkode6               (= ${binary:Version}),
         libsundials-cvode7                (= ${binary:Version}),
         libsundials-cvodes7               (= ${binary:Version}),
         libsundials-ida7                  (= ${binary:Version}),
         libsundials-idas6                 (= ${binary:Version}),
         libsundials-kinsol7               (= ${binary:Version}),
         libsundials-nvecserial7           (= ${binary:Version}),
         libsundials-nvecparallel-mpi7     (= ${binary:Version}),
         libsundials-nvecparallel-pthread7 (= ${binary:Version}),
         libsundials-nvecparallel-openmp7  (= ${binary:Version}),
         libsundials-nvecparallel-hypre7   (= ${binary:Version}),
         libsundials-nvecparallel-petsc7   (= ${binary:Version}),
         libsundials-sunlinsol5            (= ${binary:Version}),
         libsundials-sunmatrix5            (= ${binary:Version}),
         cmake,
         mpi-default-dev,
         libhypre-dev,
         petsc-dev,
         gfortran,
         pkgconf,
         ${misc:Depends}
Description: Package providing everything for SUNDIALS dev work
 This package contains all development files necessary to build applications
 using SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). All examples and documentation links live in this package as well.

Package: libsundials-fortran-dev
Architecture: any
Section: libdevel
Depends: libsundials-core7                 (= ${binary:Version}),
         libsundials-arkode6               (= ${binary:Version}),
         libsundials-cvode7                (= ${binary:Version}),
         libsundials-cvodes7               (= ${binary:Version}),
         libsundials-ida7                  (= ${binary:Version}),
         libsundials-idas6                 (= ${binary:Version}),
         libsundials-kinsol7               (= ${binary:Version}),
         libsundials-nvecserial7           (= ${binary:Version}),
         libsundials-nvecparallel-mpi7     (= ${binary:Version}),
         libsundials-nvecparallel-pthread7 (= ${binary:Version}),
         libsundials-nvecparallel-openmp7  (= ${binary:Version}),
         libsundials-nvecparallel-hypre7   (= ${binary:Version}),
         libsundials-nvecparallel-petsc7   (= ${binary:Version}),
         libsundials-sunlinsol5            (= ${binary:Version}),
         libsundials-sunmatrix5            (= ${binary:Version}),
         cmake,
         mpi-default-dev,
         libhypre-dev,
         petsc-dev,
         gfortran,
         pkgconf,
         ${misc:Depends}
Description: Package providing everything for SUNDIALS dev work. Fortran files
 This package contains all development fortran files necessary to build
 applications using SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers). All examples and documentation links live in this package
 as well.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
#export CTEST_OUTPUT_ON_FAILURE=1

include /usr/share/dpkg/architecture.mk

HYPRE_VERSION=$(shell dpkg -s libhypre-dev | grep Version | awk '{print $$2}')
HYPRE_LIB=$(shell if dpkg --compare-versions $(HYPRE_VERSION) lt 2.20.0-1exp3~ ; then echo HYPRE_core; else echo HYPRE; fi)

extra_flags += \
	-DCMAKE_Fortran_COMPILER=gfortran \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_STATIC_LIBS:BOOL=ON \
	-DBUILD_FORTRAN_MODULE_INTERFACE:BOOL=ON \
	-DENABLE_MPI:BOOL=ON \
	-DSUNDIALS_INDEX_SIZE=32 \
	\
	-DENABLE_LAPACK:BOOL=OFF\
	\
	-DEXAMPLES_ENABLE_C:BOOL=ON \
	-DEXAMPLES_ENABLE_CXX:BOOL=ON \
	-DEXAMPLES_ENABLE_F2003:BOOL=ON \
	-DEXAMPLES_INSTALL:BOOL=ON \
	\
	-DENABLE_OPENMP:BOOL=ON \
	-DENABLE_PTHREAD:BOOL=ON \
	\
	-DENABLE_KLU:BOOL=ON \
	-DKLU_INCLUDE_DIR=/usr/include/suitesparse \
	-DKLU_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	\
	-DENABLE_PETSC:BOOL=ON \
	\
	-DENABLE_HYPRE:BOOL=ON \
	-DHYPRE_INCLUDE_DIR=/usr/include/hypre \
	-DHYPRE_LIBRARY=-l$(HYPRE_LIB) \
	\
	-DCMAKE_C_FLAGS=-fcommon



# Debian doesn't ship superlu-mt currently, so I turn off this support
extra_flags += -DENABLE_SUPERLUMT:BOOL=OFF


BUILDDIR = $(CURDIR)/debian/build

empty :=
space := $(empty)$(empty)

SKIP_TEST_ARCH_LIST = s390x powerpc ppc64 sparc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_TEST_ARCH_LIST)$(space)))
  SKIP_TEST_LIST += test_fnvector_mpimanyvector_mod_1 test_fnvector_mpimanyvector_mod_4 test_fnvector_manyvector_mod \
                    test_fsunlinsol_dense_mod test_fsunlinsol_klu_mod
endif


%:
	dh $@ --buildsystem=cmake  --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

# Hack from https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=839387
# The OpenMPI variable prevents FTBFS when there are not enough CPUs (see #910352, #849974 and #1086386)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	cd debian/build; \
	if [ "x$(SKIP_TEST_LIST)" != "x" ]; then echo "set(CTEST_CUSTOM_TESTS_IGNORE $(SKIP_TEST_LIST) )" >> CTestCustom.cmake; fi; \
	PRTE_MCA_rmaps_default_mapping_policy=":oversubscribe" ../nofakeroot ctest
endif

override_dh_auto_install:
	dh_auto_install
# I strip out all the RPATH/RUNPATH tags from my shared objects. These all point
# to libraries that actually live in standard locations, so the tags are not
# needed
	find debian/tmp/ -name '*.so' -o -name '*.so.*' -exec chrpath -d '{}' \;

# Strip extra license file
	rm debian/tmp/usr/include/sundials/LICENSE

# We copy READMEs by hand because they need to be renamed
execute_after_dh_installdocs:
	mkdir -p debian/libsundials-dev/usr/share/doc/libsundials-dev
	for module in arkode cvode cvodes ida idas kinsol; do \
		cp src/$${module}/README.md debian/libsundials-dev/usr/share/doc/libsundials-dev/README.$${module}.md; \
	done

override_dh_compress:
	dh_compress -Xexamples/

execute_after_dh_auto_clean:
	rm -rf $(BUILDDIR)

=== debian/tests/control ===
Tests: arkode, cvode, cvodes, kinsol, sunnonlinsol
Depends: build-essential, libsundials-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg1,dversionmangle=s/\+dfsg1//g,repack,compression=xz,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/sundials-$1\.tar\.gz/ \
  https://github.com/LLNL/sundials/tags .*/v?(\d\S+)\.tar\.gz
